--
-- Fendt vario 700 series
-- Specialization class for Fendt 700 series
-- @Authors of original scripts used: Manuel Leithner (SFM-Modding),Modelleicher (www.schwabenmodding.bplaced.net),Templaer, JoXXer, Knagsted, Mofa-Killer, Face, Heady, other do not remember!!
-- @author  Ago-Modding
-- @date  2/10/2015
---@ fix by Stefan Biedenstein (mogli)
--	for use this specialization on your mods...
-- 	@ Ago-Systemtech: https://www.facebook.com/ago.systemtech (Modhoster Team)
--	free for non commercial-usage! -------------
Vario700serieV2 = {};

function Vario700serieV2.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;
function Vario700serieV2:load(xmlFile)
	Vario700serieV2.override();
	
	self.isSelectable = true
	self.LucePorta = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LucePorta#index"));
	self.doorIObject = nil;
	---------------------CAM INTERNA MOBILE---------------------
	self.internalCamera = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.internalCamera#index"));
	self.camPositionX = 0;
	self.camPositionZ = 0;
	self.camPositionY = 0;
	
	self.updateFuelIndicators = SpecializationUtil.callSpecializationsFunction("updateFuelIndicators");
	self.ledriserva = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ledriserva#index"));
	self.ledriservaActive = false;
	self.riserva = 60;
	------------REALISTIC INDOOR CAM------------
	self.ric = {};
	self.ric.directionPart = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.realisticIndoorCam#directionPart"));
	------------extra menu---------------
	self.helpPanelPoxX = Utils.getNoNil(getXMLFloat(xmlFile,  "vehicle.helpPanel#posX"), 0.6295);
	self.helpPanelPoxY = Utils.getNoNil(getXMLFloat(xmlFile,  "vehicle.helpPanel#posY"), 0.436);
    self.helpPanelWidth = 0.36;
    self.helpPanelHeight = 0.44;
    self.helpPanelOverlay = Overlay:new("helpPanel", Utils.getFilename("Textur/EXTRAMENUFENDT.png", self.baseDirectory), self.helpPanelPoxX, self.helpPanelPoxY, self.helpPanelWidth, self.helpPanelHeight);
	self.extraMenu = false;
	----------------------- FRONT WIPER ANIMATION---------------------
	local wiperFrontAnimRootNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiperFront#rootNode"));
	self.wiperFrontAnimCharSet = 0;
	if wiperFrontAnimRootNode ~= nil and wiperFrontAnimRootNode ~= 0 then
		self.wiperFrontAnimCharSet = getAnimCharacterSet(wiperFrontAnimRootNode);
		if self.wiperFrontAnimCharSet ~= 0 then
			local clip = getAnimClipIndex(self.wiperFrontAnimCharSet, getXMLString(xmlFile, "vehicle.wiperFront#clip"));
			assignAnimTrackClip(self.wiperFrontAnimCharSet, 0, clip);
			setAnimTrackLoopState(self.wiperFrontAnimCharSet, 0, true);
			local wiperFrontAnimSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.wiperFront#speedScale"), 1);
			setAnimTrackSpeedScale(self.wiperFrontAnimCharSet, 0, wiperFrontAnimSpeedScale);
			self.wiperFrontAnimDuration = getAnimClipDuration(self.wiperFrontAnimCharSet, clip);
		end;
	end;
	self.iswiperFrontActive = false;
	self.finishwiperFront = true;
	--------------------------REAR WIPER ANIMATION----------------------
	local wiperBackAnimRootNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiperBack#rootNode"));
	self.wiperBackAnimCharSet = 0;
	if wiperBackAnimRootNode ~= nil and wiperBackAnimRootNode ~= 0 then
		self.wiperBackAnimCharSet = getAnimCharacterSet(wiperBackAnimRootNode);
		if self.wiperBackAnimCharSet ~= 0 then
			local clip = getAnimClipIndex(self.wiperBackAnimCharSet, getXMLString(xmlFile, "vehicle.wiperBack#clip"));
			assignAnimTrackClip(self.wiperBackAnimCharSet, 0, clip);
			setAnimTrackLoopState(self.wiperBackAnimCharSet, 0, true);
			local wiperBackAnimSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.wiperBack#speedScale"), 1);
			setAnimTrackSpeedScale(self.wiperBackAnimCharSet, 0, wiperBackAnimSpeedScale);
			self.wiperBackAnimDuration = getAnimClipDuration(self.wiperBackAnimCharSet, clip);
		end;
	end;
	self.iswiperBackActive = false;
	self.finishwiperBack = true;
	-------------------------PEDALI-------------------------
	local PedaleGasNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PedaleGas#index"));
    if PedaleGasNode ~= nil then
        self.PedaleGas = {};
        self.PedaleGas.node = PedaleGasNode;
		self.PedaleGas.maxSpeed = getXMLInt(xmlFile, "vehicle.PedaleGas#maxSpeed");
		local x1,y1,z1 = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.PedaleGas#minRot"));
		local x2,y2,z2 = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.PedaleGas#maxRot"));
		self.PedaleGas.rotMin = {math.rad(Utils.getNoNil(x1,0)),math.rad(Utils.getNoNil(y1,0)),math.rad(Utils.getNoNil(z1,0))};
		self.PedaleGas.rotMax = {math.rad(Utils.getNoNil(x2,0)),math.rad(Utils.getNoNil(y2,0)),math.rad(Utils.getNoNil(z2,0))};
    end;
    local PedaleFrenoNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PedaleFreno#index"));
    if PedaleFrenoNode ~= nil then
        self.PedaleFreno = {};
        self.PedaleFreno.node = PedaleFrenoNode;
		local x1,y1,z1 = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.PedaleGas#minRot"));
		local x2,y2,z2 = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.PedaleGas#maxRot"));
		self.PedaleFreno.rotMin = {math.rad(Utils.getNoNil(x1,0)),math.rad(Utils.getNoNil(y1,0)),math.rad(Utils.getNoNil(z1,0))};
		self.PedaleFreno.rotMax = {math.rad(Utils.getNoNil(x2,0)),math.rad(Utils.getNoNil(y2,0)),math.rad(Utils.getNoNil(z2,0))};
        self.PedaleFreno.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.PedaleFreno#rotTime"), 1)*1000;
        self.PedaleFrenoIsActive = false;
    end;
	-------------------------- LEVE ----------------------
	self.levaindicatori = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.levaindicatori#index"));
	self.LevaHandbrake = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LevaHandbrake#index"));
	self.HANDBRAKE_LED = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.HANDBRAKE_LED#index"));
	--------------------------LED-------------------------
	self.batteriaicona = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.batteriaicona#index"));
	self.candelette = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.candelette#index"));
	self.DASHBOARD_ON = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.DASHBOARD_ON#index"));
	self.Olio_Led = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Olio_Led#index"));
    self.LedHazard = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LedHazard#index"));
    self.ledLampeggiante = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ledLampeggiante#index"));
	self.LedStart = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LedStart#index"));
	self.LedStart_ON = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LedStart_ON#index"));
	self.LedStart_OFF = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LedStart_OFF#index"));
	self.Display_Digitali = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Display_Digitali#index"));
	self.ledFrontwork = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ledFrontwork#index"));
	self.ledRearwork = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ledRearwork#index"));
	self.LedBraccio = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LedBraccio#index"));
	self.PTOLed = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PTOLed#index"));
	self.MONITOR_VARIO_HIRED = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.MONITOR_VARIO_HIRED#index"));
	self.Cruise = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Cruise#index"));
	self.LED_AVANTI = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LED_AVANTI#index"));
	self.LED_INDIETRO = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LED_INDIETRO#index"));
	self.terzaPuntaOk = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.puntaOk#index"));
	self.terzaPuntaTubi1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.puntaTubi1#index"));
	self.terzaPuntaTubi2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.puntaTubi2#index"));
	self.terzaPuntaNoOk = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.puntaNoOk#index"));
	self.Hook = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Hook#index"));
	------------------ SWITCHES---------------
	self.numSwitches = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.switches#count"),0);
	self.switch = {};
	for i=1, self.numSwitches do
		local objname = string.format("vehicle.switches.switch" .. "%d", i);
		self.switch[i] = {};
		self.switch[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#index"));
	end;
	------------- GASOLIO INDICATORI----------
	self.fuelIndicatorsGroup = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fuelIndicators#index"));
	self.numFuelIndicators = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.fuelIndicators#count"), 0);
	self.fuelIndicators = {};
    for i=1, self.numFuelIndicators do
        local objname = string.format("vehicle.fuelIndicators.fuelIndicator" .. "%d", i);
		self.fuelIndicators[i] = {};
        self.fuelIndicators[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.fuelIndicators[i].rotNode,true);
    end;
	------------- ROTORE LAMPEGGIANTE----------
	self.RotoreLampe1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.RotoreLampe1#index"));
	self.RotoreLampe2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.RotoreLampe2#index"));
	 	--------------------------GIUNTI ASSALE------------------------
	self.giuntoDestro = {};
	self.giuntoDestro.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.giuntoDestro#index"));
	self.giuntoDestro.speedFactor = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.giuntoDestro#speedFactor"), 2);
	self.giuntoSinistro = {};
	self.giuntoSinistro.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.giuntoSinistro#index"));
	self.giuntoSinistro.speedFactor = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.giuntoSinistro#speedFactor"), 2);
	-----------------SOUND RISERVA------------------
    fuelwarningSoundFile = Utils.getFilename("Sound/fuelwarning.wav", self.baseDirectory);
    self.fuelwarningSoundId = createSample("fuelwarningSound");
    loadSample(self.fuelwarningSoundId, fuelwarningSoundFile, false);
    self.fuelwarningPlaying = false;
	self.playedSound = false;
	
	-- MOGLI START --
	---------------FREEEZE STEERING---------------
	self.freezeRotatedTime = 0
	-- self.getIsActiveForInputNew = Vario700serieV2.getIsActiveForInputNew
	self.getIsActiveForInput = Vario700serieV2.getIsActiveForInputNew
	-- MOGLI END --
end;
function Vario700serieV2:delete()
end;
function Vario700serieV2:readStream(streamId, connection)
end;
function Vario700serieV2:writeStream(streamId, connection)
end;
function Vario700serieV2:readUpdateStream(streamId, timestamp, connection)
	if connection:getIsServer() then
		if streamReadBool(streamId) then
		end;
	end;
end;
function Vario700serieV2:writeUpdateStream(streamId, connection, dirtyMask)
	if not connection:getIsServer() then
		if streamWriteBool(streamId, bitAND(dirtyMask, self.vehicleDirtyFlag) ~= 0) then
        end;
    end;
end;
function Vario700serieV2:mouseEvent(posX, posY, isDown, isUp, button)
end;
function Vario700serieV2:keyEvent(unicode, sym, modifier, isDown)
end;

	-- MOGLI START --
	
function Vario700serieV2:getIsActiveForInputNew(onlyTrueIfSelected)
	if g_gui.currentGui ~= nil or g_currentMission.isPlayerFrozen then
		return false;
	end;

	if self.isEntered then
		if onlyTrueIfSelected == nil or onlyTrueIfSelected then
			return self.selectedImplement == nil;
		else
			return true;
		end;
	end;

	return false;
end;

	-- MOGLI END --


function Vario700serieV2:update(dt)
	-------------LIFT-HIDRO----------------
	if self:getIsActive() then
	if self.isMotorStarted then
		if self.isHired == true then
				setVisibility(self.MONITOR_VARIO_HIRED, true);
				setVisibility(self.Cruise, true);			
			else
				setVisibility(self.MONITOR_VARIO_HIRED, false);
				setVisibility(self.Cruise , false);			
		end;
		
	end;
	-- MOGLI START --
	--if self:getIsActiveForInput(false) then
	if self:getIsActiveForInput(false) then
	-- MOGLI END --
		if InputBinding.hasEvent(InputBinding.MENUEXTRA) then
			self.extraMenu = not self.extraMenu;
		end;
	end;
 
	--------------------------GIUNTI ASSALE------------------------
		local x,y,z = getRotation(self.wheels[1].driveNode);
		setRotation(self.giuntoDestro.node, 0 ,0, x*self.giuntoDestro.speedFactor);
		local x,y,z = getRotation(self.wheels[1].driveNode);
		setRotation(self.giuntoSinistro.node, 0 ,0, x*self.giuntoSinistro.speedFactor);
	end;
	-------------------- PLAFONIERA -------------------
	if self.doorIObject == nil then
		for k,iObject in pairs(self.interactiveObjects) do
			if iObject.name == g_i18n:getText("leftDoor") then
				self.doorIObject = iObject;
		end;
		end;
	end;
	------------------LED RISERVA----------------------
	if self.isEntered then
		if self.fuelFillLevel < 60 then
			self.riserva = self.riserva - dt;
			if self.playedSound == false then
				playSample(self.fuelwarningSoundId,1,1,0);
				self.playedSound = true;
			end;
			self.ledriservaActive = true;
		else
			self.playedSound = false;
			self.ledriservaActive = false;
		end;
		setVisibility(self.ledriserva,self.ledriservaActive);
		self:updateFuelIndicators();
	end;
	---------------------CAM INTERNA MOBILE---------------------
      if self.camIndex == 1 then
	 if self:getIsActive() then
		if InputBinding.isPressed(InputBinding.MOVECAMLEFT2) then
			self.camPositionX = self.camPositionX + 0.03;
			if self.camPositionX >= 0.3 then
				self.camPositionX = 0.3;
			end;
		end;
		if InputBinding.isPressed(InputBinding.MOVECAMRIGHT2) then
			self.camPositionX = self.camPositionX - 0.03;
			if self.camPositionX <= -0.3 then
				self.camPositionX = -0.3;
			end;
		end;
		if InputBinding.isPressed(InputBinding.MOVECAMFORWARD2) then
			self.camPositionZ = self.camPositionZ + 0.03;
			if self.camPositionZ >= 0.3 then
				self.camPositionZ = 0.3;
			end;
		end;
				if InputBinding.isPressed(InputBinding.MOVECAMBACK2) then
			self.camPositionZ = self.camPositionZ - 0.03;
			if self.camPositionZ <= -0.2 then
				self.camPositionZ = -0.2;
			end;
		end;
		if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) then
			self.camPositionY = self.camPositionY + 0.02;
			if self.camPositionY >= 0.15 then
				self.camPositionY = 0.15;
			end;
		end;
		if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) then
			self.camPositionY = self.camPositionY - 0.02;
			if self.camPositionY <= -0.2 then
				self.camPositionY = -0.2;
			end;
		end;
		if Input.isKeyPressed(Input.KEY_z) then
			self.camPositionX = 0;
			self.camPositionZ = 0;
			self.camPositionY = 0;
		end;
		if self.internalCamera ~= nil then
			setTranslation(self.internalCamera, self.camPositionX, self.camPositionZ, self.camPositionY);
		end;
   	end;
	end;
	--------------REALISTIC INDOOR CAM------------------------
	if self:getIsActive() then
			local ax, ay, az = getWorldTranslation(self.ric.directionPart);
			local bx = 0;
			local by = 1100000;
			local bz = 0;
			x, y, z = worldDirectionToLocal(getParent(self.ric.directionPart), bx-ax, by-ay, bz-az);
			setDirection(self.ric.directionPart, x, y, z, 0, 0, 1);
			    ------------------LAMPEGGIANTI------------------
	    if self.beaconLightsActive then
			rotate(self.RotoreLampe1, 0, self.beaconLights[1].speed*dt, 0);
			rotate(self.RotoreLampe2, 0, self.beaconLights[2].speed*dt, 0);
		end;
	end;
end;
function Vario700serieV2:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    return BaseMission.VEHICLE_LOAD_OK;
end;
function Vario700serieV2:updateTick(dt)
	-- MOGLI START --
	---------------FREEEZE STEERING---------------
	if self.isMotorStarted then	
		self.freezeRotatedTime = self.rotatedTime
	elseif self:getIsActive() then
		self.rotatedTime = self.freezeRotatedTime
	end
	-- MOGLI END --
	
  if self:getIsActive() then
		if self.isMotorStarted then	
			setVisibility(self.batteriaicona, false);
			setVisibility(self.candelette, false);
			setVisibility(self.DASHBOARD_ON, true);
			setVisibility(self.Olio_Led, true);
			setVisibility(self.LedStart_ON, true);
			setVisibility(self.LedStart_OFF, false);
			-- setVisibility(self.LedStart, true);
			setVisibility(self.Display_Digitali, true);
			setVisibility(self.fuelIndicatorsGroup, true);
			setVisibility(self.LedBraccio, true);
		else		
			setVisibility(self.batteriaicona, true);
			setVisibility(self.candelette, true);
			setVisibility(self.DASHBOARD_ON, false);
			setVisibility(self.Olio_Led, false);
			setVisibility(self.LedStart_ON, false);
			setVisibility(self.LedStart_OFF, true);
			-- setVisibility(self.LedStart, false);
		    setVisibility(self.Display_Digitali, false);
			setVisibility(self.fuelIndicatorsGroup, false);
			setVisibility(self.LedBraccio, false);
		end;
		for k, implement in pairs(self.attachedImplements) do
				if implement.object ~= nil then
					if implement.object.isTurnedOn then
						setVisibility(self.PTOLed, true);
					else
						setVisibility(self.PTOLed, false);
					end;
				end;
		end;
		-------------------PEDALI--------------------------------
		if self.camIndex == 1 then
			 if self.PedaleGas ~= nil then
				local percent = (self.lastSpeed*self.speedDisplayScale*3600) / self.PedaleGas.maxSpeed;
				local minRot = self.PedaleGas.rotMin;
				local maxRot = self.PedaleGas.rotMax;
				local x = minRot[1] + (maxRot[1] - minRot[1]) * percent;
				local y = minRot[2] + (maxRot[2] - minRot[2]) * percent;
				local z = minRot[3] + (maxRot[3] - minRot[3]) * percent;
				setRotation(self.PedaleGas.node, x, y, z);
	        end;
		end;
		if self.camIndex == 2 then
			if self.PedaleGas ~= nil then
				local percent = (self.lastSpeed*self.speedDisplayScale*3600) / self.PedaleGas.maxSpeed;
				local minRot = self.PedaleGas.rotMin;
				local maxRot = self.PedaleGas.rotMax;
				local x = minRot[1] + (maxRot[1] - minRot[1]) * percent;
				local y = minRot[2] + (maxRot[2] - minRot[2]) * percent;
				local z = minRot[3] + (maxRot[3] - minRot[3]) * percent;
				setRotation(self.PedaleGas.node, x, y, z);
			end;
		end;
	end;
		---------------------- WIPERS -----------------
	if self.isMotorStarted then
		if not self.finishwiperFront then
			if getAnimTrackTime(self.wiperFrontAnimCharSet, 0) % self.wiperFrontAnimDuration <= 100 then
				setAnimTrackTime(self.wiperFrontAnimCharSet, 0, 0.0);
				disableAnimTrack(self.wiperFrontAnimCharSet, 0);
				self.finishwiperFront = true;
			end;
		end;
		if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
			if not self.iswiperFrontActive then
				enableAnimTrack(self.wiperFrontAnimCharSet, 0);
				self.iswiperFrontActive = true;
			end;
		else
			if self.iswiperFrontActive then
				self.iswiperFrontActive = false;
				self.finishwiperFront = false;
			end;
		end;
		if not self.finishwiperBack then
			if getAnimTrackTime(self.wiperBackAnimCharSet, 0) % self.wiperBackAnimDuration <= 100 then
				setAnimTrackTime(self.wiperBackAnimCharSet, 0, 0.0);
				disableAnimTrack(self.wiperBackAnimCharSet, 0);
				self.finishwiperBack = true;
			end;
		end;
		if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
			if not self.iswiperBackActive then
				enableAnimTrack(self.wiperBackAnimCharSet, 0);
				self.iswiperBackActive = true;
			end;
		else
			if self.iswiperBackActive then
				self.iswiperBackActive = false;
				self.finishwiperBack = false;
			end;
		end;
		for _, part in pairs(self.movingParts) do
			part.isDirty = true;
		end;
	end;
	--------------------SWITCH------------------------------
	
	if self.switch[1] ~= nil then
		if self.isMotorStarted then
			setRotation(self.switch[1], math.rad(0), math.rad(-60), math.rad(0));
		else
			setRotation(self.switch[1], math.rad(0), math.rad(0), math.rad(0));
		end;
	end;
	if self.LevaHandbrake ~= nil then
		if      self.dCcheckModule ~= nil 
				and self.driveControl  ~= nil
				and self:dCcheckModule("handBrake")
				and self.driveControl.handBrake.isActive then
			setRotation(self.LevaHandbrake, math.rad(0), math.rad(0), math.rad(0));
		else
			setRotation(self.LevaHandbrake, math.rad(90), 0, 0);
		end;
	end;
	if self.HANDBRAKE_LED ~= nil then
		if  self.dCcheckModule ~= nil 
				and self.driveControl  ~= nil
				and self:dCcheckModule("handBrake")
				and self.driveControl.handBrake.isActive then
			setVisibility(self.HANDBRAKE_LED, true);
			setVisibility(self.LedStart, true);
		else
			setVisibility(self.HANDBRAKE_LED, false);
			setVisibility(self.LedStart, false);
		end;
	end
	if self.ledFrontwork ~= nil then
		 local i = 1
		 if self.B3.work[i].a then
			setVisibility(self.ledFrontwork, true);
		else
			setVisibility(self.ledFrontwork, false);
		end;
	 end;
	if self.ledRearwork ~= nil then
		 local i = 2
		 if self.B3.work[i].a then
			setVisibility(self.ledRearwork, true);
		else
			setVisibility(self.ledRearwork, false);
		end;
	end;
	if self.LucePorta ~= nil and self.doorIObject ~= nil then
		setVisibility(self.LucePorta, self.doorIObject.isOpen);
	end;
	
	-- MOGLI START --
	if self.levaindicatori ~= nil then
		local targetAngle = 0
		if     self.turnSignalState == Vehicle.TURNSIGNAL_LEFT then 
			targetAngle = -20
		elseif self.turnSignalState == Vehicle.TURNSIGNAL_RIGHT then 
			targetAngle = 20
		end
		setRotation( self.levaindicatori, 0, 0, math.rad( targetAngle ) )
	end
	
	if self.LedHazard  ~= nil then
		if self.turnSignalState == Vehicle.TURNSIGNAL_HAZARD then
			setVisibility(self.LedHazard , true);
		else
			setVisibility(self.LedHazard , false);
		end;
	end;

	if self.l2gsGetShuttleDirection ~= nil then
		local dir = self:l2gsGetShuttleDirection()
		if     dir > 0 then
			setVisibility(self.LED_AVANTI, true);
			setVisibility(self.LED_INDIETRO, false);
			setVisibility(self.LedStart, false);
		elseif dir < 0 then
			setVisibility(self.LED_INDIETRO, true);
			setVisibility(self.LED_AVANTI, false);
			setVisibility(self.LedStart, false);
		else
			setVisibility(self.LED_INDIETRO, false);
			setVisibility(self.LED_AVANTI, false);
			setVisibility(self.LedStart, true);
		end;
	end
	-- MOGLI END --
	
	if self.ledLampeggiante ~= nil then
		 if self.beaconLightsActive then
		    setVisibility(self.ledLampeggiante, true);
		 else
		   setVisibility(self.ledLampeggiante, false);
		end;
	end;
end;
function Vario700serieV2:updateFuelIndicators()
	local amountOfFuelPerIndicator = self.fuelCapacity/11;
	local timesToIterate = self.fuelFillLevel/amountOfFuelPerIndicator;
	timesToIterate = math.floor(timesToIterate);
	if self.oldTimesToIterate ~= timesToIterate then
		for i=1, self.numFuelIndicators do
			setVisibility(self.fuelIndicators[i].rotNode, false);
		end;
		for i=1, timesToIterate do
			setVisibility(self.fuelIndicators[i].rotNode, true);
		end;
	end;
	self.oldTimesToIterate = timesToIterate;
end;
function Vario700serieV2:draw()
  -- MOGLI START --

	if self.l2gsDrawShuttleDirection ~= nil then
		self:l2gsDrawShuttleDirection()
	end
	-- MOGLI END --
	if      self.dCcheckModule ~= nil 
			and self.driveControl  ~= nil
			and self:dCcheckModule("handBrake") then
		if self.isEntered then
			if self.driveControl.handBrake.isActive then
				if Input.isKeyPressed(Input.KEY_w) then
					g_currentMission:addWarning(g_i18n:getText("handbrakeRELEASE"), 0.015, 0.030);
					g_currentMission:addHelpButtonText(g_i18n:getText("driveControlHandbrake"), InputBinding.driveControlHandbrake);
				end;
			end;
		end;
		if self.isEntered then
			if self.driveControl.handBrake.isActive then
				if Input.isKeyPressed(Input.KEY_s) then
					g_currentMission:addWarning(g_i18n:getText("handbrakeRELEASE"), 0.015, 0.030);
					g_currentMission:addHelpButtonText(g_i18n:getText("driveControlHandbrake"), InputBinding.driveControlHandbrake);
				end;
			end;
		end;
	end;
	if      self.dCcheckModule ~= nil 
			and self.driveControl  ~= nil
			and self:dCcheckModule("shuttle") then
		if not self.driveControl.shuttle.isActive   then
			g_currentMission:addHelpButtonText(g_i18n:getText("driveControlShuttleOnOff"), InputBinding.driveControlShuttleOnOff);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("driveControlShuttleOnOff"), InputBinding.driveControlShuttleOnOff);
		end;
	end;
	--------------------------
	if self.extraMenu then
		setTextBold(false);
		if self.helpPanelOverlay ~= nil then
			self.helpPanelOverlay:render();
		end;
	 if self.extraMenu then
			setTextColor(0,0.45,0,1);
			renderText(0.6445, 0.84, 0.018,"       EXTRA MENU - FENDT VARIO 700 Series v.4 ");
			setTextColor(0,0,0,0.9);
			renderText(0.6445, 0.78, 0.018,(string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.AXIS_MOVEABLE_SPECCHIOSXY700).."/RIGHT " ..g_i18n:getText("AXIS_MOVEABLE_SPECCHIOSXY700_1"))));
			renderText(0.6445, 0.76, 0.018,(string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.AXIS_MOVEABLE_SPECCHIOSXX700).."/UP " ..g_i18n:getText("AXIS_MOVEABLE_SPECCHIOSXX700_1"))));
			renderText(0.6445, 0.74, 0.018,(string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.AXIS_MOVEABLE_SPECCHIODXY700).."/KEYPAD 6 " ..g_i18n:getText("AXIS_MOVEABLE_SPECCHIODXY700_1"))));
			renderText(0.6445, 0.72, 0.018,(string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.AXIS_MOVEABLE_SPECCHIODXX700).."/KEYPAD 8 " ..g_i18n:getText("AXIS_MOVEABLE_SPECCHIODXX700_1"))));
			renderText(0.6445, 0.70, 0.018, " -------------------------------------------");
		end;
		if self.B3["work"][3].a then
			setTextColor(0,1,0,1);
			renderText(0.6445, 0.62, 0.018, (string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.LucePorta1)..": "..g_i18n:getText("LucePorta1"))));
		else
			setTextColor(0,0,0,1);
			renderText(0.6445, 0.62, 0.018, (string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.LucePorta1)..": "..g_i18n:getText("LucePorta1"))));
		end;
		if self.B3["work"][1].a then
			setTextColor(0,1,0,1);
			renderText(0.6445, 0.60, 0.018, (string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.FARILAVOROANT)..": "..g_i18n:getText("FARILAVOROANT"))));
		else
			setTextColor(0,0,0,1);
			renderText(0.6445, 0.60, 0.018, (string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.FARILAVOROANT)..": "..g_i18n:getText("FARILAVOROANT"))));
		end;
		if self.B3["work"][2].a then
			setTextColor(0,1,0,1);
			renderText(0.6445, 0.58, 0.018, (string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.FARILAVOROPOST)..": "..g_i18n:getText("FARILAVOROPOST"))));
		else
			setTextColor(0,0,0,1);
			renderText(0.6445, 0.58, 0.018, (string.format(InputBinding.getKeyNamesOfDigitalAction(InputBinding.FARILAVOROPOST)..": "..g_i18n:getText("FARILAVOROPOST"))));
		end;
		end;
	if not self.extraMenu  then
		g_currentMission:addHelpButtonText(g_i18n:getText("ACTIVATE_EXTRAMENU"), InputBinding.MENUEXTRA);
	else
		g_currentMission:addHelpButtonText(g_i18n:getText("DEACTIVATE_EXTRAMENU"), InputBinding.MENUEXTRA);
	end;
end;
function Vario700serieV2:onEnter()
        if self.isMotorStarted then
			setVisibility(self.batteriaicona, false);
			setVisibility(self.candelette, false);
			setVisibility(self.DASHBOARD_ON, true);
			 setVisibility(self.Olio_Led, true);
			setVisibility(self.LedBraccio, true);
			setVisibility(self.Display_Digitali, true);
			setVisibility(self.LedStart, true);
		else
			setVisibility(self.LedStart, false);
			setVisibility(self.batteriaicona, true);
			setVisibility(self.candelette, true);
			setVisibility(self.DASHBOARD_ON, false);
			 setVisibility(self.Olio_Led, false);
			setVisibility(self.LedBraccio, false);
		    setVisibility(self.Display_Digitali, false);
		end
	if self.iswiperFrontActive then
		enableAnimTrack(self.wiperFrontAnimCharSet, 0);
	end;
		if self.iswiperBackActive then
		enableAnimTrack(self.wiperBackAnimCharSet, 0);
	end;
end;
function Vario700serieV2:attachImplement(implement)
	local jointType = implement.object.attacherJoint.jointType;
	local jointIndex = implement.jointDescIndex;
	if jointType == Vehicle.JOINTTYPE_IMPLEMENT then
		if jointIndex == 1 then
			setVisibility(self.terzaPuntaOk, true);
			setVisibility(self.terzaPuntaTubi1, true);
			setVisibility(self.terzaPuntaTubi2, true);
			setVisibility(self.terzaPuntaNoOk, false);
			setVisibility(self.Hook, false);
		end;
	end;
end;
function Vario700serieV2:detachImplement(implementIndex)
	local implement = self.attachedImplements[implementIndex];
	local jointIndex = implement.jointDescIndex;
	if jointIndex == 1 then
		setVisibility(self.terzaPuntaOk, false);
		setVisibility(self.terzaPuntaTubi1, false);
		setVisibility(self.terzaPuntaTubi2, false);
		setVisibility(self.terzaPuntaNoOk, true);
		setVisibility(self.Hook, true);
	end;
end;

function Vario700serieV2:onLeave()
	    if self.isMotorStarted then
			setVisibility(self.batteriaicona, false);
			setVisibility(self.candelette, false);
			setVisibility(self.DASHBOARD_ON, true);
			 setVisibility(self.Olio_Led, true);
			setVisibility(self.Display_Digitali, true);
			setVisibility(self.LedBraccio, true);
		else
			setVisibility(self.batteriaicona, true);
			setVisibility(self.candelette, true);
			setVisibility(self.DASHBOARD_ON, false);
			 setVisibility(self.Olio_Led, false);
			setVisibility(self.Display_Digitali, false);
			setVisibility(self.LedBraccio, false);
	     end
	if self.iswiperBackActive then
		disableAnimTrack(self.wiperBackAnimCharSet, 0);
	end;
	    if self.iswiperFrontActive then
		disableAnimTrack(self.wiperFrontAnimCharSet, 0);
	end;
end;


function Vario700serieV2.override() -- we do this to allow all mods to be loaded before we override it.
	if not Utils.updateHardPointStoreObject then
		local hardPoint = _G["HardPointExtension"];
		
		if hardPoint ~= nil then
			local hardPointGUIScreen = hardPoint["g_hardPointGUIScreen"];
			
			hardPointGUIScreen.updateObjectList = function(self)
				self:setMessage("", "");
				self.HPObjectList:deleteListItems();
				self.currentObjectList = {};
				
				if self.selectedHPLocation ~= 0 then
					local currentLocation = self.currentLocationList[self.selectedHPLocation];
					
					if currentLocation.allowAdding and currentLocation.parentAllowAdding then
						-- if (currentLocation.attachedObjectID == nil or currentLocation.requireObject) then
							local type = currentLocation.type;
							
							if self.vehicles[self.selectedVehicle] ~= nil then
								local vehicle = self.vehicles[self.selectedVehicle].vehicle;
								local hardPointObjects = vehicle.hardPointObjects;
								
								local objects = {};
								for i = 1, table.getn(hardPointObjects) do
									if hardPointObjects[i].type == type then
										table.insert(objects, hardPointObjects[i]);
									end;
								end;
								
								for i = 1, table.getn(objects) do
									if (objects[i].showInStore == nil or objects[i].showInStore ~= nil and objects[i].showInStore) then
										self.currentObject = objects[i];
										
										local item = self.objectListItemTemplate:clone(self.HPObjectList);
										item:updateAbsolutePosition();
										
										local location = self.currentLocationList[self.selectedHPLocation];
										local objectId = location.attachedObjectID;
										
										if attached then
											item:applyProfile("HP_List_Item_Attached");
										end;
										
										table.insert(self.currentObjectList, self.currentObject);
										
										self.currentObject = nil;
									end;
								end;
							end;
						-- else
							-- only show the attached part
							-- local hardPointObject = self.vehicles[self.selectedVehicle].vehicle.hardPointObjects[currentLocation.attachedObjectID];
							
							-- self.currentObject = hardPointObject;
							-- local item = self.objectListItemTemplate:clone(self.HPObjectList);
							-- item:updateAbsolutePosition();
							-- table.insert(self.currentObjectList, self.currentObject);
							-- self.currentObject = nil;
						-- end;
					elseif not currentLocation.allowAdding and currentLocation.allowAddingError ~= nil then -- let forced stop add there own error!
						local parentName = self.vehicles[self.selectedVehicle].vehicle.hardPoints[currentLocation.locationId].type;
						self:setMessage(HardPointGUIScreen.ERROR, string.format(currentLocation.allowAddingError, parentName));
					else
						-- no objects can be attached as parent got no object attached!
						local parentName = "InvalidType";
						if currentLocation.parentDisabledId ~= nil then
							parentName = self.vehicles[self.selectedVehicle].vehicle.hardPoints[currentLocation.parentDisabledId].type;
						end;
						
						self:setMessage(HardPointGUIScreen.ERROR, string.format(g_i18n:getText("HARDPOINT_ERROR_5"), parentName));
					end;
				end;
				
				self.HPObjectList:selectItemByNumber(1);
			end;
		end;
		
		Utils.updateHardPointStoreObject = true;
	end;
end;